#include "setup_functions.h"


template <class indep_var>  indep_var function_eval(const indep_var * x, int n){
  int  i, j;
  indep_var fad=1;
  indep_var fi=0;
/*---------------------------------------------------------------------------------*/
/*the one dimensional output variable is fad, in other words, f: R^n -> R. f(x) = fad */
/*  You may use all basic functions, for a complete list consult the ADOL-C manuel */
    for(i=0; i<n; i++)
    {
        if(i%100 ==0)
        fad = fad+pow(x[i]-10,2);
        else
        fad = fad+pow(x[i],2);
    }
    for(i=0; i<n; i++)
    {
        if(i%101 ==10)
        fi = fi+pow(x[i]-3,2);
        else
             fi = fi+pow(x[i],2);
    }
    fad= fad*fi;
    return fad;
}//*/

ObjectiveFunction * setup_function_eval(int dimension){
double * x_initial = new double [dimension];
/* CHOOSE INITIAL POINT HERE!!! *******************************/
    for(int i=0; i<dimension ; i++) x_initial[i] =1.0;
/*************************************************************/
  ObjectiveFunction * OFfunction_eval= new ObjectiveFunction(dimension, x_initial, function_eval<double>, function_eval<adouble>, "User defined function_eval");
 return(OFfunction_eval); }



template double function_eval<double>(const double  *x, int n);
template adouble function_eval<adouble>(const adouble  *x, int n);
