
#include "setup_functions.h"
template <class indep_var> indep_var rosenbrock(const indep_var * x, int n){
  int  i, j;
  indep_var fad=1;
  indep_var fi=0;
  /*---------------------------------------------------------------------------------*/
  //  The Generalized RosenBrock Function

  for(i=0; i<n-1; i++)
    fad = fad +100*pow(x[n-1] - pow(x[i],2),2) + pow(1-x[i],2);


  return(fad);
}

template double rosenbrock<double>(const double  *x, int n);
template adouble rosenbrock<adouble>(const adouble  *x, int n);
ObjectiveFunction * setup_rosenbrock(int dimension){
double * x_initial = new double [dimension];
    for(int i=0; i<dimension ; i++) x_initial[i] =0.0;
  ObjectiveFunction * OFrosenbrock = new ObjectiveFunction(dimension, x_initial, rosenbrock<double>, rosenbrock<adouble>, "rosenbrock");
 return(OFrosenbrock); }
