#include <adolc/adolc.h> 
template <class indep_var> indep_var function_eval(const indep_var  *x, int n);
template <class indep_var> indep_var pspdoc(const indep_var  *x, int n);
template <class indep_var> indep_var scon1dls(const indep_var  *x, int n);
template <class indep_var> indep_var sinquad(const indep_var  *x, int n);
template <class indep_var> indep_var nondquar(const indep_var  *x, int n);
template <class indep_var> indep_var bc4(const indep_var  *x, int n);
template <class indep_var> indep_var cragglevy(const indep_var  *x, int n);
template <class indep_var> indep_var augmlagn(const indep_var  *x, int n);
template <class indep_var> indep_var arwhead(const indep_var  *x, int n);
template <class indep_var> indep_var cosine(const indep_var  *x, int n);
template <class indep_var> indep_var bdexp(const indep_var  *x, int n);
template <class indep_var> indep_var brybnd(const indep_var  *x, int n);
template <class indep_var> indep_var bdqrtic(const indep_var  *x, int n);
template <class indep_var> indep_var lminsurf(const indep_var  *x, int n);
template <class indep_var> indep_var chainwood(const indep_var  *x, int n);
template <class indep_var> indep_var morebv(const indep_var  *x, int n);
template <class indep_var> indep_var noncvxu2(const indep_var  *x, int n);
template <class indep_var> indep_var ncvxqp3(const indep_var  *x, int n);
template <class indep_var> indep_var ncvxbqp1(const indep_var  *x, int n);
template <class indep_var> indep_var chainros_trigexp(const indep_var  *x, int n);
template <class indep_var> indep_var chain_rosenbrock(const indep_var  *x, int n);
template <class indep_var> indep_var rosenbrock(const indep_var  *x, int n);
template <class indep_var> indep_var binary(const indep_var  *x, int n);
template <class indep_var> indep_var toiqmerg(const indep_var  *x, int n);
template <class indep_var> indep_var extrosnb(const indep_var  *x, int n);

void cosine_initial_point( double *x_initial, const int dimension);
void lminsurf_initial_point ( double *x_initial, const int dimension);
void bdexp_initial_point ( double *x_initial, const int dimension);
void bdqrtic_initial_point ( double *x_initial, const int dimension);
void augmlagn_initial_point ( double *x_initial, const int dimension);
void scon1dls_initial_point ( double *x_initial, const int dimension);
void ncvxqp3_initial_point ( double *x_initial, const int dimension);
void extrosnb_initial_point ( double *x_initial, const int dimension);
void ncvxbqp1_initial_point ( double *x_initial, const int dimension);
void morebv_initial_point ( double *x_initial, const int dimension);
void binary_initial_point ( double *x_initial, const int dimension);
void chain_rosenbrock_initial_point ( double *x_initial, const int dimension);
void brybnd_initial_point ( double *x_initial, const int dimension);
void nondquar_initial_point ( double *x_initial, const int dimension);
void function_eval_initial_point ( double *x_initial, const int dimension);
void sinquad_initial_point ( double *x_initial, const int dimension);
void arwhead_initial_point ( double *x_initial, const int dimension);
void noncvxu2_initial_point ( double *x_initial, const int dimension);
void rosenbrock_initial_point ( double *x_initial, const int dimension);
void chainwood_initial_point ( double *x_initial, const int dimension);
void pspdoc_initial_point ( double *x_initial, const int dimension);
void chainros_trigexp_initial_point ( double *x_initial, const int dimension);
void toiqmerg_initial_point ( double *x_initial, const int dimension);
void cragglevy_initial_point ( double *x_initial, const int dimension);
void bc4_initial_point ( double *x_initial, const int dimension);
